package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;


/**
 * 实体[TSSDItem] 数据对象
 */
@TableName(value = "T_SRFTSSDITEM",resultMap = "TSSDItemResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class TSSDItem extends EntityBase implements Serializable{

    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    @Dict(dictName = "ionicdemo_TSDayTypeCodeList")
    private String hourtype;
    @Dict(dictName = "ionicdemo_TSHourCodeList")
    private String hourvalue;
    @Dict(dictName = "ionicdemo_TSMinuteTypeCodeList")
    private String minutetype;
    @Dict(dictName = "ionicdemo_TSMinuteCodeList")
    private String minutevalue;
    @Dict(dictName = "ionicdemo_TSMonthDayTypeCodeList")
    private String monthdaytype;
    @Dict(dictName = "ionicdemo_TSDayCodeList")
    private String monthdayvalue;
    @Dict(dictName = "ionicdemo_TSMonthTypeCodeList")
    private String monthtype;
    @Dict(dictName = "ionicdemo_TSMonthCodeList")
    private String monthvalue;
    @Dict(dictName = "ionicdemo_TSMonthWeekTypeCodeList")
    private String monthweektype;
    @Dict(dictName = "ionicdemo_TSWeekCodeList")
    private String monthweekvalue;
    @Dict(dictName = "ionicdemo_TSSecondTypeCodeList")
    private String secondtype;
    @Dict(dictName = "ionicdemo_TSSecondCodeList")
    private String secondvalue;
    @TableId(value= "tssditemid",type=IdType.UUID)//指定主键生成策略
    private String tssditemid;
    private String tssditemname;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    private Integer version;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[小时]
     *  @param hourtype
     */
    public void setHourtype(String hourtype){
        if(StringUtils.isEmpty(hourtype))
            hourtype=null;
        this.hourtype = hourtype;
        this.set("hourtypedirtyflag",true);
    }
    /**
     *  获取属性值[小时]
     */
    public String getHourtype(){
        return this.hourtype;
    }
    /**
     *  重置属性值[小时]
     */
    public void resetHourtype(){
        this.set("hourtypedirtyflag",false);
        this.hourtype = null;
    }
    /**
     *  设置属性值[指定小时]
     *  @param hourvalue
     */
    public void setHourvalue(String hourvalue){
        if(StringUtils.isEmpty(hourvalue))
            hourvalue=null;
        this.hourvalue = hourvalue;
        this.set("hourvaluedirtyflag",true);
    }
    /**
     *  获取属性值[指定小时]
     */
    public String getHourvalue(){
        return this.hourvalue;
    }
    /**
     *  重置属性值[指定小时]
     */
    public void resetHourvalue(){
        this.set("hourvaluedirtyflag",false);
        this.hourvalue = null;
    }
    /**
     *  设置属性值[分钟]
     *  @param minutetype
     */
    public void setMinutetype(String minutetype){
        if(StringUtils.isEmpty(minutetype))
            minutetype=null;
        this.minutetype = minutetype;
        this.set("minutetypedirtyflag",true);
    }
    /**
     *  获取属性值[分钟]
     */
    public String getMinutetype(){
        return this.minutetype;
    }
    /**
     *  重置属性值[分钟]
     */
    public void resetMinutetype(){
        this.set("minutetypedirtyflag",false);
        this.minutetype = null;
    }
    /**
     *  设置属性值[指定分钟]
     *  @param minutevalue
     */
    public void setMinutevalue(String minutevalue){
        if(StringUtils.isEmpty(minutevalue))
            minutevalue=null;
        this.minutevalue = minutevalue;
        this.set("minutevaluedirtyflag",true);
    }
    /**
     *  获取属性值[指定分钟]
     */
    public String getMinutevalue(){
        return this.minutevalue;
    }
    /**
     *  重置属性值[指定分钟]
     */
    public void resetMinutevalue(){
        this.set("minutevaluedirtyflag",false);
        this.minutevalue = null;
    }
    /**
     *  设置属性值[月天]
     *  @param monthdaytype
     */
    public void setMonthdaytype(String monthdaytype){
        if(StringUtils.isEmpty(monthdaytype))
            monthdaytype=null;
        this.monthdaytype = monthdaytype;
        this.set("monthdaytypedirtyflag",true);
    }
    /**
     *  获取属性值[月天]
     */
    public String getMonthdaytype(){
        return this.monthdaytype;
    }
    /**
     *  重置属性值[月天]
     */
    public void resetMonthdaytype(){
        this.set("monthdaytypedirtyflag",false);
        this.monthdaytype = null;
    }
    /**
     *  设置属性值[指定月天]
     *  @param monthdayvalue
     */
    public void setMonthdayvalue(String monthdayvalue){
        if(StringUtils.isEmpty(monthdayvalue))
            monthdayvalue=null;
        this.monthdayvalue = monthdayvalue;
        this.set("monthdayvaluedirtyflag",true);
    }
    /**
     *  获取属性值[指定月天]
     */
    public String getMonthdayvalue(){
        return this.monthdayvalue;
    }
    /**
     *  重置属性值[指定月天]
     */
    public void resetMonthdayvalue(){
        this.set("monthdayvaluedirtyflag",false);
        this.monthdayvalue = null;
    }
    /**
     *  设置属性值[月份]
     *  @param monthtype
     */
    public void setMonthtype(String monthtype){
        if(StringUtils.isEmpty(monthtype))
            monthtype=null;
        this.monthtype = monthtype;
        this.set("monthtypedirtyflag",true);
    }
    /**
     *  获取属性值[月份]
     */
    public String getMonthtype(){
        return this.monthtype;
    }
    /**
     *  重置属性值[月份]
     */
    public void resetMonthtype(){
        this.set("monthtypedirtyflag",false);
        this.monthtype = null;
    }
    /**
     *  设置属性值[指定月份]
     *  @param monthvalue
     */
    public void setMonthvalue(String monthvalue){
        if(StringUtils.isEmpty(monthvalue))
            monthvalue=null;
        this.monthvalue = monthvalue;
        this.set("monthvaluedirtyflag",true);
    }
    /**
     *  获取属性值[指定月份]
     */
    public String getMonthvalue(){
        return this.monthvalue;
    }
    /**
     *  重置属性值[指定月份]
     */
    public void resetMonthvalue(){
        this.set("monthvaluedirtyflag",false);
        this.monthvalue = null;
    }
    /**
     *  设置属性值[月周]
     *  @param monthweektype
     */
    public void setMonthweektype(String monthweektype){
        if(StringUtils.isEmpty(monthweektype))
            monthweektype=null;
        this.monthweektype = monthweektype;
        this.set("monthweektypedirtyflag",true);
    }
    /**
     *  获取属性值[月周]
     */
    public String getMonthweektype(){
        return this.monthweektype;
    }
    /**
     *  重置属性值[月周]
     */
    public void resetMonthweektype(){
        this.set("monthweektypedirtyflag",false);
        this.monthweektype = null;
    }
    /**
     *  设置属性值[指定周天]
     *  @param monthweekvalue
     */
    public void setMonthweekvalue(String monthweekvalue){
        if(StringUtils.isEmpty(monthweekvalue))
            monthweekvalue=null;
        this.monthweekvalue = monthweekvalue;
        this.set("monthweekvaluedirtyflag",true);
    }
    /**
     *  获取属性值[指定周天]
     */
    public String getMonthweekvalue(){
        return this.monthweekvalue;
    }
    /**
     *  重置属性值[指定周天]
     */
    public void resetMonthweekvalue(){
        this.set("monthweekvaluedirtyflag",false);
        this.monthweekvalue = null;
    }
    /**
     *  设置属性值[秒钟]
     *  @param secondtype
     */
    public void setSecondtype(String secondtype){
        if(StringUtils.isEmpty(secondtype))
            secondtype=null;
        this.secondtype = secondtype;
        this.set("secondtypedirtyflag",true);
    }
    /**
     *  获取属性值[秒钟]
     */
    public String getSecondtype(){
        return this.secondtype;
    }
    /**
     *  重置属性值[秒钟]
     */
    public void resetSecondtype(){
        this.set("secondtypedirtyflag",false);
        this.secondtype = null;
    }
    /**
     *  设置属性值[指定秒钟]
     *  @param secondvalue
     */
    public void setSecondvalue(String secondvalue){
        if(StringUtils.isEmpty(secondvalue))
            secondvalue=null;
        this.secondvalue = secondvalue;
        this.set("secondvaluedirtyflag",true);
    }
    /**
     *  获取属性值[指定秒钟]
     */
    public String getSecondvalue(){
        return this.secondvalue;
    }
    /**
     *  重置属性值[指定秒钟]
     */
    public void resetSecondvalue(){
        this.set("secondvaluedirtyflag",false);
        this.secondvalue = null;
    }
    /**
     *  设置属性值[任务时刻策略项标识]
     *  @param tssditemid
     */
    public void setTssditemid(String tssditemid){
        if(StringUtils.isEmpty(tssditemid))
            tssditemid=null;
        this.tssditemid = tssditemid;
        this.set("tssditemiddirtyflag",true);
    }
    /**
     *  获取属性值[任务时刻策略项标识]
     */
    public String getTssditemid(){
        return this.tssditemid;
    }
    /**
     *  重置属性值[任务时刻策略项标识]
     */
    public void resetTssditemid(){
        this.set("tssditemiddirtyflag",false);
        this.tssditemid = null;
    }
    /**
     *  设置属性值[任务时刻策略项]
     *  @param tssditemname
     */
    public void setTssditemname(String tssditemname){
        if(StringUtils.isEmpty(tssditemname))
            tssditemname=null;
        this.tssditemname = tssditemname;
        this.set("tssditemnamedirtyflag",true);
    }
    /**
     *  获取属性值[任务时刻策略项]
     */
    public String getTssditemname(){
        return this.tssditemname;
    }
    /**
     *  重置属性值[任务时刻策略项]
     */
    public void resetTssditemname(){
        this.set("tssditemnamedirtyflag",false);
        this.tssditemname = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[版本]
     *  @param version
     */
    public void setVersion(Integer version){
        this.version = version;
        this.set("versiondirtyflag",true);
    }
    /**
     *  获取属性值[版本]
     */
    public Integer getVersion(){
        return this.version;
    }
    /**
     *  重置属性值[版本]
     */
    public void resetVersion(){
        this.set("versiondirtyflag",false);
        this.version = null;
    }
    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetHourtype();
        resetHourvalue();
        resetMinutetype();
        resetMinutevalue();
        resetMonthdaytype();
        resetMonthdayvalue();
        resetMonthtype();
        resetMonthvalue();
        resetMonthweektype();
        resetMonthweekvalue();
        resetSecondtype();
        resetSecondvalue();
        resetTssditemid();
        resetTssditemname();
        resetUpdatedate();
        resetUpdateman();
        resetVersion();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public TSSDItem copyTo(TSSDItem targetEntity)
	{
		BeanCopier copier=BeanCopier.create(TSSDItem.class, TSSDItem.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetTssditemid();
		return targetEntity;
	}
}